// ---------------------------------------------------------------- //
// IBM Confidential                                                 //
//                                                                  //
// OCO Source Materials                                             //
//                                                                  //
// Product(s):                                                      //
//     5733-XJ1                                                     //
//                                                                  //
// (C)Copyright IBM Corp.  2015, 2015                               //
//                                                                  //
// The Source code for this program is not published  or otherwise  //
// divested of its trade secrets,  irrespective of what has been    //
// deposited with the U.S. Copyright Office.                        //
// ---------------------------------------------------------------- //
//
// This script can be used for uninstalling ACS on Windows.
//



var args = WScript.Arguments;
var printhelp = "no";
var install_type_shared = "no";
var source;
var target1;
var local_install_path;



// Print the help text
function print_help() {
  WScript.Echo("                  IBM i Access Client Solutions Installation\n\
\n\
Name:\n\
  uninstall_acs.js -- uninstall the ACS product.\n\
\n\
Syntax:\n\
  uninstall_acs.js\n\
\n\
Description:\n\
Uninstalls local product files, desktop icons, and file associations for IBM i Access Client Solutions (ACS).\n\
\n\
  ");

}



// Begin: Main
// Do some parm checking and verification
if (args.length > 0) {
  printhelp = "yes";
}

if ("yes" == printhelp) {
  print_help();
}
else {

  // Main
  //
  fso = new ActiveXObject("Scripting.FileSystemObject");
  Shell1 = new ActiveXObject("WScript.Shell");

  // Find local install path
  DocumentsPath = Shell1.SpecialFolders("MyDocuments");
  InstallPath = fso.GetAbsolutePathName(DocumentsPath+"\\..\\");

  // Determine local install path
  target1 = (InstallPath + "\\IBM");
  local_install_path = (InstallPath + "\\IBM\\ClientSolutions");
  // Create the IBM directory if it does not exist so we can write to the log
  if (!fso.FolderExists(target1)) {
    fso.CreateFolder(target1);
  }


  // Get the directory of this script
  var script_path = WScript.ScriptFullName;
  var script_file = fso.GetFile(script_path);
  var script_dir = fso.GetParentFolderName(script_file);
  // Source directory of unpacked product should be the parent of this script
  source = fso.GetAbsolutePathName(script_dir+"\\..\\");

  // Open install_acs_log.txt trace file
  outputfile = new ActiveXObject("Scripting.FileSystemObject");
  install_log = outputfile.OpenTextFile(target1+"\\install_acs_log.txt",8,true); // Open for append
  var sTime = new Date();
  install_log.writeline("BEGIN----uninstall---- "+sTime+" ----uninstall----BEGIN");
  install_log.writeline("script_path:  "+script_path);
  install_log.writeline("source path: "+source);
  install_log.writeline("local install path: "+local_install_path);

  // Delete file associations for 32
  Shell2 = new ActiveXObject("WScript.Shell");
  win32_exe = "\\Start_Programs\\Windows_i386-32\\acslaunch_win-32.exe";
  // Use source directory because if this is a shared install, that is the only binary available
  acslaunch32_exe = source + win32_exe;  // Location of Windows binary
  if (fso.FileExists(acslaunch32_exe)) {
    clear_command32 = "\""+acslaunch32_exe + "\" -norecurse /PLUGIN=fileassoc dttx dtfx hod bchx ws /c";                            
    install_log.writeline(clear_command32);
    try {
      Shell2.Run(clear_command32,1,true);
      install_log.writeline("File associations deleted: "+win32_exe);
    }
    catch(error) {
      install_log.writeline("Skipping deleting file associations for 32bit.");
    }
  }

  // Delete file associations for 64
  Shell3 = new ActiveXObject("WScript.Shell");
  win64_exe = "\\Start_Programs\\Windows_x86-64\\acslaunch_win-64.exe";
  // Use source directory because if this is a shared install, that is the only binary available
  acslaunch64_exe = source + win64_exe;  // Location of Windows binary
  if (fso.FileExists(acslaunch64_exe)) {
    clear_command64 = "\""+acslaunch64_exe + "\" -norecurse /PLUGIN=fileassoc dttx dtfx hod bchx ws /c";
    install_log.writeline(clear_command64);
    try {
      Shell3.Run(clear_command64,1,true);
      install_log.writeline("File associations deleted: "+win64_exe);
    }
    catch(error) {
      install_log.writeline("Skipping deleting file associations for 64bit.");
    }
  }


  // Delete product files
  if (fso.FolderExists(local_install_path)) {
    fso.DeleteFolder(local_install_path);
    install_log.writeline("Deleting folder: "+local_install_path);
  }

  // Delete desktop link for product files
  Shell4 = new ActiveXObject("WScript.Shell");
  DesktopPath = Shell4.SpecialFolders("Desktop");
  product_link = DesktopPath + "\\Access Client Solutions.lnk";
  if (fso.FileExists(product_link)) {
    fso.DeleteFile(product_link);
    install_log.writeline("Deleting desktop shortcut: "+product_link);  //line 142
  }

  // Delete desktop link for session mgr
  // Shell4 = new ActiveXObject("WScript.Shell");
  // DesktopPath = Shell4.SpecialFolders("Desktop");
  sessionMgr_link = DesktopPath + "\\ACS Session Mgr.lnk";
  if (fso.FileExists(sessionMgr_link)) {
    fso.DeleteFile(sessionMgr_link);
    install_log.writeline("Deleting desktop shortcut: "+sessionMgr_link); // line 151
  }


  sTime = new Date();
  install_log.writeline("END----uninstall----- "+sTime+" ----uninstall----END");

  install_log.Close();
  WScript.Echo("IBM i Access Client Solution has been uninstalled.");

} // End: Main
